VERSION 5.00
Begin VB.Form TMC12PWM 
   Caption         =   "PCI-TMC12A PWM Output Sample Program"
   ClientHeight    =   2700
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5610
   LinkTopic       =   "Form1"
   ScaleHeight     =   2700
   ScaleWidth      =   5610
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cbxBoardNo 
      BackColor       =   &H0080FF80&
      Height          =   315
      Left            =   1320
      TabIndex        =   9
      Text            =   "-----Select Board-----"
      Top             =   120
      Width           =   2055
   End
   Begin VB.TextBox Text1 
      BackColor       =   &H00C0FFFF&
      Height          =   2535
      Left            =   3480
      MultiLine       =   -1  'True
      TabIndex        =   8
      Text            =   "TMC12PWM.frx":0000
      Top             =   120
      Width           =   2055
   End
   Begin VB.TextBox tbxFrequency 
      BackColor       =   &H00C0FFC0&
      Height          =   375
      Left            =   1200
      TabIndex        =   3
      Text            =   "1000.0"
      Top             =   600
      Width           =   855
   End
   Begin VB.TextBox tbxDuty 
      BackColor       =   &H00C0FFC0&
      Height          =   375
      Left            =   1200
      TabIndex        =   2
      Text            =   "10.0"
      Top             =   960
      Width           =   855
   End
   Begin VB.CommandButton cmdPWM 
      Caption         =   "START PWM"
      Height          =   615
      Left            =   0
      TabIndex        =   1
      Top             =   1440
      Width           =   1575
   End
   Begin VB.CommandButton Command1 
      Caption         =   "STOP PWM"
      Height          =   615
      Left            =   1560
      TabIndex        =   0
      Top             =   1440
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Select Board"
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "Frequency"
      Height          =   375
      Left            =   120
      TabIndex        =   7
      Top             =   600
      Width           =   975
   End
   Begin VB.Label Label5 
      Caption         =   "Hz"
      Height          =   375
      Left            =   2040
      TabIndex        =   6
      Top             =   600
      Width           =   495
   End
   Begin VB.Label Label3 
      Caption         =   "Duty Rate"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   1080
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "%"
      Height          =   375
      Left            =   2040
      TabIndex        =   4
      Top             =   960
      Width           =   495
   End
End
Attribute VB_Name = "TMC12PWM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Refer to Sec. 5.6 of PCI-TMC12 User's Manual
'CNT1 select ECLK1 (JP22)
'connect the external CNT signal to Pin1 of CON1

Option Explicit
Dim wTotalBoards As Integer
Dim wBoardNo As Integer
Dim wRtn As Integer
Dim wCounter As Integer, wMode As Integer

Dim sDevInfo(0 To MAX_BOARD_NUMBER - 1) As IXUD_DEVICE_INFO
Dim sCardInfo(0 To MAX_BOARD_NUMBER - 1) As IXUD_CARD_INFO
Dim sSelDevInfo As IXUD_DEVICE_INFO
Dim sSelCardInfo As IXUD_CARD_INFO

Dim TempByte As Byte, cMode As Byte


Private Sub cmdPWM_Click()
Dim CountVal As Long
Dim DutyVal As Long
Dim SourceCLK As Single

wBoardNo = cbxBoardNo.ListIndex


SourceCLK = 80000#  '//80 kHz

wCounter = 0
wMode = 3
CountVal = CInt(SourceCLK / CSng(Me.tbxFrequency.Text)) 'Internal Clock is CLK2 = 80 kHz
wRtn = Ixud_SetCounter(wBoardNo, wCounter, wMode, CountVal) 'Counter 1 Output Frequency

wCounter = 1
wMode = 1
DutyVal = CountVal * (CSng(Me.tbxDuty.Text) * 0.01)
wRtn = Ixud_SetCounter(wBoardNo, wCounter, wMode, DutyVal) 'Counter 2 Outupt Duty

Me.Caption = "PWM Enable " + "[" + CStr(SourceCLK / CSng(CountVal)) + " Hz," + CStr((CSng(DutyVal) / CSng(CountVal)) * 100#) + " %]"

End Sub

Private Sub Command1_Click()

wRtn = Ixud_DisableCounter(wBoardNo, 0) 'Stop Counter 0
wRtn = Ixud_DisableCounter(wBoardNo, 1) 'Stop Counter 1

TMC12PWM.Caption = "PWM Disable"

End Sub

Private Sub Form_Load()

Dim wBoardIndex As Integer
Dim szModelName As String * 20

'//Driver Initial
wRtn = Ixud_DriverInit(wTotalBoards)
If (wRtn) Then
    MsgBox ("Driver Initial Error!!Error Code:" + Str(wRtn))
    End
End If

wRtn = Ixud_SearchCard(wTotalBoards, PCITMC12)
If (wRtn) Then
    MsgBox ("Search Card Error!!Error Code:" + Str(wRtn))
    End
End If

'//Get Card Information
For wBoardIndex = 0 To wTotalBoards - 1

    wRtn = Ixud_GetCardInfo(wBoardIndex, sDevInfo(wBoardIndex), sCardInfo(wBoardIndex), szModelName)
    
    If (wRtn) Then
        MsgBox ("Get Card Information Err")
    End If
    
    Me.cbxBoardNo.AddItem Str(wBoardIndex) + " " + szModelName

Next

End Sub

Private Sub Form_Unload(Cancel As Integer)
wRtn = Ixud_DriverClose()

End Sub

Private Sub cbxBoardNo_Click()

Dim PortIndex As Integer
wBoardNo = cbxBoardNo.ListIndex
sSelDevInfo = sDevInfo(wBoardNo)
sSelCardInfo = sCardInfo(wBoardNo)

Me.Caption = Me.cbxBoardNo.Text + " PWM Output Sample Program"

End Sub


