#include <Windows.h> 
#include <ansi_c.h>
#include <cvirte.h>		
#include <userint.h>
#include "UniDAQ_DIO.h"
#include "UniDAQ.h" 


static int panelHandle;
WORD wRtn;
int wBoardNo;
int wBoardIndex;
WORD PortIndex; 
IXUD_DEVICE_INFO sDevInfo[MAX_BOARD_NUMBER];
IXUD_CARD_INFO sCardInfo[MAX_BOARD_NUMBER];
char szModelName[20]="Unknow Device";


int main (int argc, char *argv[])
{
	int iCardNum =0;  
	WORD wTotalBoards;
	
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "UniDAQ_DIO.uir", PANEL)) < 0)
		return -1;
	
	//Initial the resource and get total board number form driver  
	wRtn=Ixud_DriverInit(&wTotalBoards);
	if (wRtn!=0) return wRtn;

	ClearListCtrl(panelHandle, PANEL_IDC_COMBO_SelectBoard);
 
	
	InsertListItem (panelHandle, PANEL_IDC_COMBO_SelectBoard, 0,"--Select Boards--" ,0);
	
	//Get DAQ Card Information
	for(WORD wBoardIndex = 0; wBoardIndex<wTotalBoards ; wBoardIndex++)
	{
		wRtn = Ixud_GetCardInfo(wBoardIndex,&sDevInfo[wBoardIndex],&sCardInfo[wBoardIndex],szModelName);
		InsertListItem (panelHandle, PANEL_IDC_COMBO_SelectBoard, wBoardIndex, szModelName, wBoardIndex);   
	}
	
	
	DisplayPanel (panelHandle);
	RunUserInterface ();
	DiscardPanel (panelHandle);
	return 0;
}


int CVICALLBACK OnSelchangeCOMBOSelectBoard (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

	WORD wPortChNum;
	char sPortNo[32];
				
	GetCtrlIndex (panelHandle, PANEL_IDC_COMBO_SelectBoard, &wBoardNo);
	wPortChNum = sCardInfo[wBoardNo].wDIOPortWidth;
	 
	
	switch (event)
	{
		case EVENT_COMMIT:
		
		//Total D/O port
		ClearListCtrl(panelHandle, PANEL_IDC_COMBO_OutputPort);	
	
		for (PortIndex = 0; PortIndex < (sCardInfo[wBoardNo].wDIOPorts + sCardInfo[wBoardNo].wDOPorts)  ;PortIndex++)
		{	
			sprintf(sPortNo, "%02d", PortIndex);
			InsertListItem (panelHandle, PANEL_IDC_COMBO_OutputPort, -1, sPortNo ,PortIndex);
   		 }


		//Total D/I port
		ClearListCtrl(panelHandle, PANEL_IDC_COMBO_InputPort);
	
		for (PortIndex = 0; PortIndex < (sCardInfo[wBoardNo].wDIOPorts + sCardInfo[wBoardNo].wDIPorts)  ;PortIndex++)
		{	
			sprintf(sPortNo, "%02d", PortIndex);
			InsertListItem (panelHandle, PANEL_IDC_COMBO_InputPort, -1, sPortNo, PortIndex);	  
    	}
	

		break;
	}
	return 0;
}



int CVICALLBACK OnBtnDo (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	WORD wRtn;
	int wOutputPortNo;
	int wInputPortNo;
	DWORD dwDOVal;
	DWORD dwDIVal;

	GetCtrlIndex (panelHandle, PANEL_IDC_COMBO_SelectBoard, &wBoardNo); 
	GetCtrlIndex (panelHandle, PANEL_IDC_COMBO_OutputPort, &wOutputPortNo);
	GetCtrlIndex (panelHandle, PANEL_IDC_COMBO_InputPort, &wInputPortNo);
	
	switch (event)
	{
		case EVENT_COMMIT:
		  
		//Config the DIO Port
		if(sCardInfo[wBoardNo].wDIOPorts>0)
		wRtn = Ixud_SetDIOModes32(wBoardNo, 1<<wOutputPortNo);
    
		//Write digital output port Value
		GetCtrlVal (panelHandle, PANEL_IDC_EDIT_DO, &dwDOVal);
		wRtn = Ixud_WriteDO(wBoardNo,wOutputPortNo,dwDOVal);
		
		//Read digital input port Value 
		wRtn = Ixud_ReadDI(wBoardNo,wInputPortNo,&dwDIVal);
		SetCtrlVal (panelHandle, PANEL_IDC_EDIT_DI, dwDIVal);             
			
		break;
		
	}
	return 0;
}


int CVICALLBACK OnCancel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			
			//Release the resource form Driver
			wRtn = Ixud_DriverClose();
			QuitUserInterface (0);
			break;
	}
	return 0;
}
