using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;

namespace AnalogInputPolling
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


        }
        const uint dwDataNum = 4000;     
        ushort wTotalBoard, wRtn, wBoardNo;
        float[] fBuf = new float[dwDataNum];
        UniDAQ.CallBackFun FuncAddress;
        UInt32 hEvent;
        Boolean bProcessing;

        //Int16 wFrontFlag = -1;
        //Int16 wRearFlag = -1;

        UInt32 dwApcCount;
        UInt16 wBufStatus;
        UInt32 dwBufDataNum;

        Graphics gr;
      
        //Boolean bDisplay = false;
        
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[UniDAQ.MAX_BOARD_NUMBER];

        private void Form1_Load(object sender, EventArgs e)
        {

            byte[] szModeName = new byte[20];

            FuncAddress = User_Callback;

            //Initial the UniDAQ Driver 
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Initial Error!!Error Code:"+wTotalBoard.ToString());
                Close();
                return;
            }

            for (ushort wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            { 
                //Get Information for Board
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }
            
        } 
           

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
              
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            
            //Total Analog Input Channel
            cbxChannel.Items.Clear();
            if (sCardInfo[wBoardNo].wAIChannels>0)
            {
                for (int wChannelIndex = 0; wChannelIndex < sCardInfo[wBoardNo].wAIChannels; wChannelIndex++)
                {
                    cbxChannel.Items.Add("CH " + wChannelIndex.ToString());
                }

                cbxChannel.SelectedIndex = 0;
                cbxCardType.SelectedIndex = 0;
                cbxConfig.SelectedIndex = 1;
            }     
      
            this.Text = this.cbxSelBoard.Text + " Analog Input Pacer(Cont.) Sample Program";
        }

        private void btnExit_Click(object sender, EventArgs e)
        {       
            //Release the UniDAQ Driver resource
            wRtn = UniDAQ.Ixud_DriverClose();
            Application.Exit();
            this.Close();
        }    

        private void btnActive_Click(object sender, EventArgs e)
        {
            UInt32 dwTempAPC = 0;
            
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            if (btnActive.Text == "&ACTIVE")
            {
                //Config the Analog Input Setting
                wRtn = UniDAQ.Ixud_ConfigAIEx(wBoardNo, 2, 2048, (ushort)cbxCardType.SelectedIndex, 0,UniDAQ.ENABLEDMAAI);
                btnActive.Text = "&STOP";
                btnExit.Enabled = false;
                //bDisplay = true;

                if (wRtn>0)
                {
                    MessageBox.Show("AI Config Error!!Error Code:" + wRtn.ToString());
                    btnActive_Click(sender, e);
                }
                
                gr = pbxDisplay.CreateGraphics();

                hEvent = 0;

                //Register APC Source = 1 Event Type = 3(APC_INT(2) +Hardware Interrupt(1))
                wRtn = UniDAQ.Ixud_SetEventCallback(wBoardNo, UniDAQ.IXUD_HARDWARE_INT | UniDAQ.IXUD_APC_READY_INT, 1, ref hEvent, FuncAddress, dwDataNum);
                              
                if(wRtn>0)
                {
                                
                    MessageBox.Show("Set Callback Function Error!!Error Code:" + wRtn.ToString());
                    btnActive_Click(sender, e);
                }            
         
                //wFrontFlag = -1; //Initial Buffer Flag
                //wRearFlag = -1; //Initial Buffer Flag
                //Start Analog Input Pacer on Continuous Mode
                wRtn = UniDAQ.Ixud_StartAI(wBoardNo, (ushort)cbxChannel.SelectedIndex, (ushort)cbxConfig.SelectedIndex,Convert.ToSingle(tbxSRate.Text) ,0);
                if (wRtn > 0)
                {
                    MessageBox.Show("Start AI Error!!Error Code:" + wRtn.ToString());
                    btnActive_Click(sender, e);
                }    
            }
            else
            {                  
                
                //Stop Analog Input Pacer
                wRtn = UniDAQ.Ixud_StopAI(wBoardNo);
                if (wRtn > 0)
                {
                    MessageBox.Show("Stop AI Error!!Error Code:" + wRtn.ToString());
                    btnActive_Click(sender, e);
                }

                gr.Dispose();
                //Remove the Callback Function
                wRtn = UniDAQ.Ixud_RemoveEventCallback(wBoardNo, 1);
                                
                btnActive.Text = "&ACTIVE";
                //this.pbxDisplay_Paint(pbxDisplay, new PaintEventArgs(pbxDisplay.CreateGraphics(), Rectangle.Empty));                
                btnExit.Enabled = true;
               
            }

            while (btnActive.Text != "&ACTIVE")
            {

                if (dwApcCount > dwTempAPC)
                {
                    tbxAPC.Text = dwApcCount.ToString();
                    PlotData(gr);
                    dwTempAPC = dwApcCount;
                }
                Application.DoEvents();
            }

            gr.Dispose();
           
        }      
      
        
        private void cbxConfig_SelectedIndexChanged(object sender, EventArgs e)
        { 
            float fRangeMax=0,fRangeMin=0;
            switch (cbxConfig.SelectedIndex)
            {
                    case UniDAQ.IXUD_BI_10V:
                        fRangeMax = 10.0F;
                        fRangeMin = -10.0F;
                        break;

                    case UniDAQ.IXUD_BI_5V:
                        //1 //Bipolar +/- 5V 
                        fRangeMax = 5.0F;
                        fRangeMin = -5.0F;
                        break;

                    case UniDAQ.IXUD_BI_2V5:
                        //2 //Bipolar +/- 2.5V 
                        fRangeMax = 2.5F;
                        fRangeMin = -2.5F;
                        break;

                    case UniDAQ.IXUD_BI_1V25:
                        //3 //Bipolar +/- 1.25V 
                        fRangeMax = 1.25F;
                        fRangeMin = -1.25F;
                        break;

                    case UniDAQ.IXUD_BI_0V625:
                        //4 //Bipolar +/- 0.625V 
                        fRangeMax = 0.625F;
                        fRangeMin = -0.625F;
                        break;

                    case UniDAQ.IXUD_BI_0V3125:
                        //5 //Bipolar +/- 0.3125V 
                        fRangeMax = 0.3125F;
                        fRangeMin = -0.3125F;
                        break;

                    case UniDAQ.IXUD_BI_0V5:
                        //6 //Bipolar +/- 0.5V 
                        fRangeMax = 0.5F;
                        fRangeMin = -0.5F;
                        break;

                    case UniDAQ.IXUD_BI_0V05:
                        //7 //Bipolar +/- 0.05V 
                        fRangeMax = 0.05F;
                        fRangeMin = -0.05F;
                        break;

                    case UniDAQ.IXUD_BI_0V005:
                        //8 //Bipolar +/- 0.005V 
                        fRangeMax = 0.005F;
                        fRangeMin = -0.005F;
                        break;

                    case UniDAQ.IXUD_BI_1V:
                        //9 //Bipolar +/- 1V 
                        fRangeMax = 1.0F;
                        fRangeMin = -1.0F;
                        break;

                    case UniDAQ.IXUD_BI_0V1:
                        //10 //Bipolar +/- 0.1V 
                        fRangeMax = 0.1F;
                        fRangeMin = -0.1F;
                        break;

                    case UniDAQ.IXUD_BI_0V01:
                        //11 //Bipolar +/- 0.01V 
                        fRangeMax = 0.01F;
                        fRangeMin = -0.01F;
                        break;

                    case UniDAQ.IXUD_BI_0V001:
                        //12 //Bipolar +/- 0.001V 
                        fRangeMax = 0.001F;
                        fRangeMin = -0.001F;
                        break;

                    case UniDAQ.IXUD_UNI_20V:
                        //13 //Unipolar 0 ~ 20V 
                        fRangeMax = 20.0F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_10V:
                        //14 //Unipolar 0 ~ 10V 
                        fRangeMax = 10.0F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_5V:
                        //15 //Unipolar 0 ~ 5V 
                        fRangeMax = 5.0F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_2V5:
                        //16 //Unipolar 0 ~ 2.5V 
                        fRangeMax = 2.5F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_1V25:
                        //17 //Unipolar 0 ~ 1.25V 
                        fRangeMax = 1.25F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_0V625:
                        //18 //Unipolar 0 ~ 0.625V 
                        fRangeMax = 0.625F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_1V:
                        //19 //Unipolar 0 ~ 1V 
                        fRangeMax = 1.0F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_0V1:
                        //20 //Unipolar 0 ~ 0.1V 
                        fRangeMax = 0.1F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_0V01:
                        //21 //Unipolar 0 ~ 0.01V 
                        fRangeMax = 0.01F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_0V001:
                        //22 //Unipolar 0 ~ 0.001V 
                        fRangeMax = 0.001F;
                        fRangeMin = 0.0F;
                        break;
                    case UniDAQ.IXUD_BI_20V:
                        //23 //Bipolar 20V 
                        fRangeMax = 20.00F;
                        fRangeMin = -20.00F;
                        break;
                }

                tbxYup.Text = Convert.ToString(fRangeMax);
                tbxYdown.Text = Convert.ToString(fRangeMin);        
             
            }
        /*
        private void pbxDisplay_Paint(object sender, PaintEventArgs e)
        {             
             if (bDisplay == true)
             {   
                 Graphics g =e.Graphics;
                 PlotData(g);
             }
        }*/

        //Draw the Graphics for Analog Input Data
        private void PlotData(Graphics g)
        {
            //float Yup = 20.0F, Ydown = -20.0F;
            Single fScaleX, fScaleY;
            Pen RedPen = new Pen(Color.Red);
            Pen BlackPen = new Pen(Color.Black);
            PointF[] PointArray = new PointF[dwDataNum];
            PointF[] LPointArray = new PointF[dwDataNum];
            PointF[] LBaseArray = new PointF[1];


            for (int i = PointArray.GetLowerBound(0); i <= PointArray.GetUpperBound(0); i++)
            {
                PointArray[i].X = i;
                PointArray[i].Y = fBuf[i];
            }

            fScaleX = (float)pbxDisplay.Width / PointArray.Length;
            fScaleY = (float)(pbxDisplay.Height * 0.97) / (Convert.ToSingle(tbxYup.Text) - Convert.ToSingle(tbxYdown.Text));

            for (int i = PointArray.GetLowerBound(0); i <= PointArray.GetUpperBound(0); i++)
            {
                LPointArray[i].X = PointArray[i].X * fScaleX;
                LPointArray[i].Y = ((Convert.ToSingle(tbxYup.Text) - PointArray[i].Y) * fScaleY);

            }
            pbxDisplay.Refresh();
            g.DrawLines(RedPen, LPointArray);
            //pbxDisplay.Refresh();

            RedPen.Dispose();
            //g.Dispose();
        }

        //Callback function
        public void User_Callback(UInt32 lParm)
        {
            //Do Something.....

            if (bProcessing == false)
            {
                bProcessing = true; 
                //Get AI Data
                wRtn = UniDAQ.Ixud_GetAIBuffer(wBoardNo, dwDataNum, fBuf);
                if (wRtn > 0)
                {
                    MessageBox.Show("Get AI Buffer Error!!Error Code:" + wRtn.ToString());
                } 

                //Get Buffer Status
                wRtn = UniDAQ.Ixud_GetBufferStatus(wBoardNo, ref wBufStatus, ref dwBufDataNum);
                if (wRtn > 0)
                {
                    MessageBox.Show("Get AI Buffer Status Error!!Error Code:" + wRtn.ToString());
                }
                                
                if (wBufStatus != 1)
                {
                    MessageBox.Show("AI Buffer happen Error!!Stauts Code:" + wRtn.ToString());
                }

                dwApcCount++;
                bProcessing = false; 
            }

        }
        
       

    }
}