using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;

namespace AnalogInputPacer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


        }

        ArrayList Clabels = new ArrayList();
        ArrayList cbxChannels = new ArrayList();
        uint dwDataNum = 300;
        const UInt16 wChannels = 6;
        ushort wTotalBoard, wRtn, wBoardNo;
        float[] fBuf = new float[9999];
        ushort[] wChannelList = new ushort[wChannels];
        ushort[] wConfigList = new ushort[wChannels];
                
        //Boolean bDisplay = false;
        
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[32];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[32];

        private void Form1_Load(object sender, EventArgs e)
        {

            byte[] szModeName = new byte[20];

            Clabels = ControlArrayUtils.getControlArray(this.groupBox1, "clabel", ""); //CreatControlArray
            cbxChannels = ControlArrayUtils.getControlArray(this.groupBox1, "cbxchannel", "");  //CreatControlArray

            //Notice! The name_type of group objectives must be lowercase, because the ControlArrayUtils.cs use the "ToLower()"
  
            //Initial the UniDAQ Driver 
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Inital Error!!Error Code:"+wTotalBoard.ToString());
                Close();
                return;
            }

            for (ushort wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            { 
                //Get Information for Board
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }
            cbxSelBoard.SelectedIndex = 0;
      
        } 
           

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
            for(int i = 1; i <= 6 ; i++)
            {
               ((ComboBox)cbxChannels[i]).Items.Clear();
            }
           
              
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            
            //Total Analog Input Channel
            if (sCardInfo[wBoardNo].wAIChannels>0)
            {
                for(int wChannelIndex = 0 ; wChannelIndex <= sCardInfo[wBoardNo].wAIChannels - 1;wChannelIndex++)
                {
                    for(int i = 1 ;i<= 6;i++)
                    {
                       ((ComboBox )cbxChannels[i]).Items.Add("Channel " + wChannelIndex.ToString());
                    }
                }
                for(int i = 1;i<=6;i++)
                {
                    ((ComboBox)cbxChannels[i]).SelectedIndex = i - 1;
                } 
                cbxCardType.SelectedIndex = 0;
                cbxConfig.SelectedIndex = 0;
                tbxScanNum.SelectedIndex = 6;
            }     
      
            this.Text = this.cbxSelBoard.Text + " Analog Input Polling Scan Demo";
        }

        private void btnExit_Click(object sender, EventArgs e)
        {       
            //Release the UniDAQ Driver resource
            UniDAQ.Ixud_DriverClose();
            Application.Exit();
            this.Close();
        }    

        private void btnActive_Click(object sender, EventArgs e)
        {
             
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            if (btnActive.Text == "&ACTIVE")
            {
                //Config the Analog Input Setting
                wRtn = UniDAQ.Ixud_ConfigAI(wBoardNo, 2, 2048, (ushort)cbxCardType.SelectedIndex, 0);
                btnActive.Text = "&STOP";
                btnExit.Enabled = false;
                //bDisplay = true;

                if (wRtn>0)
                {
                    MessageBox.Show("AI Config Error!!Error Code:" + wRtn.ToString());
                    btnActive_Click(sender, e);
                }

                Graphics gr = pbxDisplay.CreateGraphics();
                while (btnActive.Text != "&ACTIVE")
                {
                   
                    for (int i = 0; i <= 5; i++) 
                    {
                        wChannelList[i] = (ushort)((ComboBox)cbxChannels[i+1]).SelectedIndex;
                        wConfigList[i] = (ushort)cbxConfig.SelectedIndex;
                    }

                        //Work on Analog Input Polling Scan
                        wRtn = UniDAQ.Ixud_PollingAIScan(wBoardNo, wChannels, wChannelList, wConfigList, dwDataNum, fBuf);
                   
                    if (wRtn > 0)
                    {
                        MessageBox.Show("Start AI Error!!Error Code:" + wRtn.ToString());
                        btnActive_Click(sender, e);
                    }

                    lDataNo.Text = dwDataNum.ToString();
                    PlotData(gr);
                                   
                    Application.DoEvents();
                }
                gr.Dispose();

            }
            else
            {
                
                btnActive.Text = "&ACTIVE";
             
                btnExit.Enabled = true;
               
            }           
           
        }      
      
        
        private void cbxConfig_SelectedIndexChanged(object sender, EventArgs e)
        { 
            float fRangeMax=0,fRangeMin=0;
            switch (cbxConfig.SelectedIndex)
            {
                    case UniDAQ.IXUD_BI_10V:
                        fRangeMax = 10.0F;
                        fRangeMin = -10.0F;
                        break;

                    case UniDAQ.IXUD_BI_5V:
                        //1 //Bipolar +/- 5V 
                        fRangeMax = 5.0F;
                        fRangeMin = -5.0F;
                        break;

                    case UniDAQ.IXUD_BI_2V5:
                        //2 //Bipolar +/- 2.5V 
                        fRangeMax = 2.5F;
                        fRangeMin = -2.5F;
                        break;

                    case UniDAQ.IXUD_BI_1V25:
                        //3 //Bipolar +/- 1.25V 
                        fRangeMax = 1.25F;
                        fRangeMin = -1.25F;
                        break;

                    case UniDAQ.IXUD_BI_0V625:
                        //4 //Bipolar +/- 0.625V 
                        fRangeMax = 0.625F;
                        fRangeMin = -0.625F;
                        break;

                    case UniDAQ.IXUD_BI_0V3125:
                        //5 //Bipolar +/- 0.3125V 
                        fRangeMax = 0.3125F;
                        fRangeMin = -0.3125F;
                        break;

                    case UniDAQ.IXUD_BI_0V5:
                        //6 //Bipolar +/- 0.5V 
                        fRangeMax = 0.5F;
                        fRangeMin = -0.5F;
                        break;

                    case UniDAQ.IXUD_BI_0V05:
                        //7 //Bipolar +/- 0.05V 
                        fRangeMax = 0.05F;
                        fRangeMin = -0.05F;
                        break;

                    case UniDAQ.IXUD_BI_0V005:
                        //8 //Bipolar +/- 0.005V 
                        fRangeMax = 0.005F;
                        fRangeMin = -0.005F;
                        break;

                    case UniDAQ.IXUD_BI_1V:
                        //9 //Bipolar +/- 1V 
                        fRangeMax = 1.0F;
                        fRangeMin = -1.0F;
                        break;

                    case UniDAQ.IXUD_BI_0V1:
                        //10 //Bipolar +/- 0.1V 
                        fRangeMax = 0.1F;
                        fRangeMin = -0.1F;
                        break;

                    case UniDAQ.IXUD_BI_0V01:
                        //11 //Bipolar +/- 0.01V 
                        fRangeMax = 0.01F;
                        fRangeMin = -0.01F;
                        break;

                    case UniDAQ.IXUD_BI_0V001:
                        //12 //Bipolar +/- 0.001V 
                        fRangeMax = 0.001F;
                        fRangeMin = -0.001F;
                        break;

                    case UniDAQ.IXUD_UNI_20V:
                        //13 //Unipolar 0 ~ 20V 
                        fRangeMax = 20.0F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_10V:
                        //14 //Unipolar 0 ~ 10V 
                        fRangeMax = 10.0F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_5V:
                        //15 //Unipolar 0 ~ 5V 
                        fRangeMax = 5.0F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_2V5:
                        //16 //Unipolar 0 ~ 2.5V 
                        fRangeMax = 2.5F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_1V25:
                        //17 //Unipolar 0 ~ 1.25V 
                        fRangeMax = 1.25F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_0V625:
                        //18 //Unipolar 0 ~ 0.625V 
                        fRangeMax = 0.625F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_1V:
                        //19 //Unipolar 0 ~ 1V 
                        fRangeMax = 1.0F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_0V1:
                        //20 //Unipolar 0 ~ 0.1V 
                        fRangeMax = 0.1F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_0V01:
                        //21 //Unipolar 0 ~ 0.01V 
                        fRangeMax = 0.01F;
                        fRangeMin = 0.0F;
                        break;

                    case UniDAQ.IXUD_UNI_0V001:
                        //22 //Unipolar 0 ~ 0.001V 
                        fRangeMax = 0.001F;
                        fRangeMin = 0.0F;
                        break;
                }

                tbxYup.Text = Convert.ToString(fRangeMax);
                tbxYdown.Text = Convert.ToString(fRangeMin);        
             
            }


        //Draw the Graphics for Analog Input Data
        private void PlotData(Graphics g)
        {
            //float Yup = 20.0F, Ydown = -20.0F;
            Single fScaleX, fScaleY;
            Pen RedPen = new Pen(Color.Red);
            Pen BlackPen = new Pen(Color.Black);
            Pen BluePen = new Pen(Color.Blue);
            Pen OrangePen = new Pen(Color.Orange);
            Pen PinkPen = new Pen(Color.Fuchsia);
            Pen GreenPen = new Pen(Color.ForestGreen);

            PointF[] PointArray = new PointF[dwDataNum*wChannels];
            PointF[] LPointArray = new PointF[dwDataNum];
            
            PointF[] LBaseArray = new PointF[1];


            for (int i = PointArray.GetLowerBound(0); i <= PointArray.GetUpperBound(0); i++)
            {
                PointArray[i].X = i;
                PointArray[i].Y = fBuf[i];
            }

            fScaleX = (float)pbxDisplay.Width / (float)PointArray.Length;
            fScaleY = (float)(pbxDisplay.Height * 0.97) / (Convert.ToSingle(tbxYup.Text) - Convert.ToSingle(tbxYdown.Text));

            pbxDisplay.Refresh();

            for (int j = 0; tbxScanNum.SelectedIndex > j; j++)
            {
                if (tbxScanNum.SelectedIndex > j)
                {
                    for (int i = LPointArray.GetLowerBound(0); i <= LPointArray.GetUpperBound(0); i++)
                    {
                        LPointArray[i].X = PointArray[(ushort)(i * wChannels + j)].X * fScaleX;
                        LPointArray[i].Y = ((Convert.ToSingle(tbxYup.Text) - PointArray[(ushort)(i * wChannels + j)].Y) * fScaleY);

                    }

                    if(j==0) g.DrawLines(RedPen, LPointArray);
                    else if (j == 1) g.DrawLines(BlackPen, LPointArray);
                    else if (j == 2) g.DrawLines(BluePen, LPointArray);
                    else if (j == 3) g.DrawLines(OrangePen, LPointArray);
                    else if (j == 4) g.DrawLines(PinkPen, LPointArray);
                    else if (j == 5) g.DrawLines(GreenPen, LPointArray);
                }

            }
            OrangePen.Dispose();
            PinkPen.Dispose();
            GreenPen.Dispose();
            RedPen.Dispose();
            BlackPen.Dispose();
            BluePen.Dispose();
          
        }

        private void tbxScanNum_SelectedIndexChanged(object sender, EventArgs e)
        {
            for (int i = 1 ;i<= 6;i++)
            {
                if( i <= tbxScanNum.SelectedIndex) 
                {
                    ((Label)Clabels[i]).Visible = true;
                    ((ComboBox)cbxChannels[i]).Visible = true;
                }
                else
                {
                    ((Label)Clabels[i]).Visible = false;
                    ((ComboBox)cbxChannels[i]).Visible = false;
                }
            }
        }

        private void tbxDataNum_TextChanged(object sender, EventArgs e)
        {
            Boolean check = false;
            uint number;
            check = uint.TryParse(this.tbxDataNum.Text, out number);
            if (check)
            {
                dwDataNum = number;
            }
            else {
                dwDataNum = 300;
                this.tbxDataNum.Text = "300";
                MessageBox.Show("Wrong Type!");
            }
        }
    

    }
}