using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;    //namespace P100X_Ns 

namespace DIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }



        ushort wTotalBoards, wRtn, wBoardNo;
        uint hEvent;
        ushort dwSamplingNum;
        ushort DANUM = 100;
        int x, d1;
        double fVal;
        UniDAQ.CallBackFun FuncAddress;
   
  
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UniDAQ.IXUD_DEVICE_INFO[] sDevInfo = new UniDAQ.IXUD_DEVICE_INFO[UniDAQ.MAX_BOARD_NUMBER];

        private void Form1_Load(object sender, EventArgs e)
        {
            FuncAddress = User_Callback_0;

        //Driver Initial
        byte[] szModeName = new byte[20];
        wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoards);
        if (wRtn != UniDAQ.Ixud_NoErr)
        {
             MessageBox.Show("Driver Initial Error!!Error Code:" + wRtn.ToString());
                Close();
                return;
        }

        //Get Card Information
        for (ushort wBoardIndex = 0; wBoardIndex <= (wTotalBoards - 1); wBoardIndex++)
        {
            wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDevInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);

            if(wRtn!= UniDAQ.Ixud_NoErr) 
            {
                MessageBox.Show("Get Card Information Err");
            }

            this.cbxBoardNo.Items.Add(Encoding.ASCII.GetString(szModeName));

        }


        this.cbxBoardNo.SelectedIndex = 0;

       
        }

       

    
        private void cmdExit_Click(object sender, EventArgs e)
        {
            wRtn = UniDAQ.Ixud_DriverClose();
            Close();
            return;
        }

        private void cbxBoardNo_SelectedIndexChanged(object sender, EventArgs e)
        {
           // ushort ChIndex;

            wBoardNo = (ushort)this.cbxBoardNo.SelectedIndex;

            cbxAOCh.Items.Clear();

            this.Text = this.cbxBoardNo.Text + " Analog Output";
        if (sCardInfo[wBoardNo].wAOChannels > 0)
        {
            for(ushort ChIndex = 0 ; ChIndex <= sCardInfo[wBoardNo].wAOChannels - 1;ChIndex++)
            {
                this.cbxAOCh.Items.Add("Channel " + ChIndex.ToString() );
            }

            cbxAOCh.SelectedIndex = 0;
            this.Text = this.cbxBoardNo.Text + " Analog Output Demo";
        }else{
            MessageBox.Show("None AO Channel");
            UniDAQ.Ixud_DriverClose();
        }
        }

        private void cmdActive_Click(object sender, EventArgs e)
        {
        int i;
        wBoardNo = (ushort)this.cbxBoardNo.SelectedIndex;
        hEvent = 0;
        dwSamplingNum = DANUM;

        if (cmdActive.Text == "&ACTIVE")
        {

            wRtn = UniDAQ.Ixud_DisableCounter(wBoardNo, 0);
            //Config the Analog Output Setting

            cmdActive.Text = "&STOP";
            cmdExit.Enabled = false;
            //bDisplay = true;

            if (wRtn > 0) 
            {

                MessageBox.Show("AO Config Error!!Error Code:" + wRtn.ToString());
                cmdActive_Click(sender, e);
            }

            hEvent = 0;
            //Active Low, Set Event to Source 0

            wRtn = UniDAQ.Ixud_SetEventCallback(wBoardNo, 9, 1, ref hEvent, FuncAddress, 0);




            if (wRtn != UniDAQ.Ixud_NoErr) 
            {
                MessageBox.Show("SetEventCallback Error" + wRtn.ToString());
                cmdActive_Click(sender, e);
            }

            //Enable source 0
            wRtn = UniDAQ.Ixud_InstallIrq(wBoardNo, 0x1);

            if (wRtn != UniDAQ.Ixud_NoErr) 
            {
                MessageBox.Show("Install IRQ Error" + wRtn.ToString());
                cmdActive_Click(sender, e);
            }

            //Enable Timer/Counter 0 to generate interrupt
            wRtn = UniDAQ.Ixud_SetCounter(wBoardNo, 0, 3, Convert.ToUInt16(4000000.0 / (Convert.ToDouble(this.tbxSRate.Text) * Convert.ToDouble(dwSamplingNum))));

            if (wRtn!= UniDAQ.Ixud_NoErr) 
            {
                MessageBox.Show("Set Timer/Counter Error" + wRtn.ToString());
                cmdActive_Click(sender, e);
            }


        }else{
            cmdActive.Text = "&ACTIVE" ;

            cmdExit.Enabled = true;

            //Enable Timer/Counter 0 to generate interrupt
            wRtn = UniDAQ.Ixud_DisableCounter(wBoardNo, 0);

            if (wRtn != UniDAQ.Ixud_NoErr) 
            {
                MessageBox.Show("Set Timer/Counter Error" + wRtn.ToString());
                cmdActive_Click(sender, e);
            }


            // Remove the Interrupt
            wRtn = UniDAQ.Ixud_RemoveIrq(wBoardNo);
            if (wRtn != 0) 
            {
                MessageBox.Show("Remove IRQ Error!!Error Code:" + wRtn.ToString());
                cmdActive_Click(sender, e);
            }
            //Remove the Callback function
            wRtn = UniDAQ.Ixud_RemoveEventCallback(wBoardNo, 1);
            if (wRtn != 0) {
                MessageBox.Show("Remvoe Callback function Error!!Error Code:" + wRtn.ToString());
                cmdActive_Click(sender, e);
            }

        }

        wRtn = UniDAQ.Ixud_ConfigAO(wBoardNo, (ushort)this.cbxAOCh.SelectedIndex, (ushort)this.cbxAOCfg.SelectedIndex);
        while (cmdActive.Text == "&STOP")
            {

            Application.DoEvents();
            wRtn = UniDAQ.Ixud_WriteAOVoltage(wBoardNo, (ushort)this.cbxAOCh.SelectedIndex, (float)fVal);
            }
        }

        public void User_Callback_0(UInt32 lParm)
        {
            
        d1 = (int)(x * 3.6);
        fVal = (Math.Sin(d1 * 3.141592654 / 180)) * 10;
       
        x = x + 1;
        if(x == 100)  x = 0;
            
        }

        
    } 
}