using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;

namespace AnalogInputPolling
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


        }
        const uint MAX_DATA_NUM = 512;     
        ushort wTotalBoard, wRtn, wBoardNo;
        UInt32[] dwDIBuf = new UInt32[MAX_DATA_NUM];        
      
        //Boolean bDisplay = false;
        
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[UniDAQ.MAX_BOARD_NUMBER];

        private void Form1_Load(object sender, EventArgs e)
        {

            byte[] szModeName = new byte[20];
            
            //Initial the UniDAQ Driver 
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Initial Error!!Error Code:"+wTotalBoard.ToString());
                Close();
                return;
            }

            for (ushort wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            { 
                //Get Information for Board
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }            
        }            

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
              
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            
            //Total Analog Input Channel
            cbxPort.Items.Clear();
            if (sCardInfo[wBoardNo].wAIChannels>0)
            {
                for (int wPortIndex = 0; wPortIndex < sCardInfo[wBoardNo].wDIOPorts + sCardInfo[wBoardNo].wDIPorts; wPortIndex++)
                {
                    cbxPort.Items.Add("Port " + wPortIndex.ToString());
                }

                cbxPort.SelectedIndex = 0;
      
            }     
      
            this.Text = this.cbxSelBoard.Text + " Digital Input Pacer Sample Program";
        }

        private void btnExit_Click(object sender, EventArgs e)
        {       
            //Release the UniDAQ Driver resource
            wRtn = UniDAQ.Ixud_DriverClose();
            Application.Exit();
            this.Close();
        }    

        private void btnActive_Click(object sender, EventArgs e)
        {
            int iDivIndex;

            iDivIndex = 8;
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            if (btnActive.Text == "&ACTIVE")
            {
                btnActive.Text = "&STOP";
                btnExit.Enabled = false;
                //bDisplay = true;

                //Graphics gr = pbxDisplay.CreateGraphics();
                while (btnActive.Text != "&ACTIVE")
                {
                    lstDIData.Items.Clear();
                    //Work on Analog Input Pacer
                    wRtn = UniDAQ.Ixud_StartDI(wBoardNo, (ushort)cbxPort.SelectedIndex, 0,Convert.ToSingle(tbxSRate.Text)*(float)1000.0 ,MAX_DATA_NUM);
                    if (wRtn > 0)
                    {
                        MessageBox.Show("Start DI Error!!Error Code:" + wRtn.ToString());
                        btnActive_Click(sender, e);
                    }
                    //Get AI Data
                    wRtn = UniDAQ.Ixud_GetDIBufferH(wBoardNo, (ushort)cbxPort.SelectedIndex, MAX_DATA_NUM, dwDIBuf);
                    if (wRtn > 0)
                    {
                        MessageBox.Show("Get DI Buffer Error!!Error Code:" + wRtn.ToString());
                        btnActive_Click(sender, e);
                    }
                    //Stop Analog Input Pacer
                    wRtn = UniDAQ.Ixud_StopDI(wBoardNo, (ushort)cbxPort.SelectedIndex);
                    if (wRtn > 0)
                    {
                        MessageBox.Show("Stop DI Error!!Error Code:" + wRtn.ToString());
                        btnActive_Click(sender, e);
                    }

                    for (int index = 0; index < MAX_DATA_NUM / iDivIndex; index++)
                    {
                        lstDIData.Items.Add("[" + ((index * iDivIndex + 0).ToString()).PadLeft(4, '0') + "]0x" + (Convert.ToString(dwDIBuf[index * iDivIndex + 0], 16)).PadLeft(8, '0') + "  [" + ((index * iDivIndex + 1).ToString()).PadLeft(4, '0') + "]0x" + (Convert.ToString(dwDIBuf[index * iDivIndex + 1], 16)).PadLeft(8, '0') + "  [" + ((index * iDivIndex + 2).ToString()).PadLeft(4, '0') + "]0x" + (Convert.ToString(dwDIBuf[index * iDivIndex + 2], 16)).PadLeft(8, '0') + "  [" + ((index * iDivIndex + 3).ToString()).PadLeft(4, '0') + "]0x" + (Convert.ToString(dwDIBuf[index * iDivIndex + 3], 16)).PadLeft(8, '0') + "  [" + ((index * iDivIndex + 4).ToString()).PadLeft(4, '0') + "]0x" + (Convert.ToString(dwDIBuf[index * iDivIndex + 4], 16)).PadLeft(8, '0') + "  [" + ((index * iDivIndex + 5).ToString()).PadLeft(4, '0') + "]0x" + (Convert.ToString(dwDIBuf[index * iDivIndex + 5], 16)).PadLeft(8, '0') + "  [" + ((index * iDivIndex + 6).ToString()).PadLeft(4, '0') + "]0x" + (Convert.ToString(dwDIBuf[index * iDivIndex + 6], 16)).PadLeft(8, '0') + "  [" + ((index * iDivIndex + 7).ToString()).PadLeft(4, '0') + "]0x" + (Convert.ToString(dwDIBuf[index * iDivIndex + 7], 16)).PadLeft(8, '0') );
                        Application.DoEvents();
                    }
  
                }
                //gr.Dispose();

            }
            else
            {
                //bDisplay = false;
                btnActive.Text = "&ACTIVE";
                //this.pbxDisplay_Paint(pbxDisplay, new PaintEventArgs(pbxDisplay.CreateGraphics(), Rectangle.Empty));                
                btnExit.Enabled = true;
               
            }           
           
        }      
 
    }
}