using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection; 

namespace AnalogOutput
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }      
       
        ushort wTotalBoard, wRtn, wBoardNo;
       
        const uint MAX_DATA_NUM = 512; 
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UInt32[] dwDOBuf = new UInt32[MAX_DATA_NUM];
                
        private void Form1_Load(object sender, EventArgs e)
        {

            byte[] szModeName = new byte[20];
            //Driver Initial
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Initial Error!!Error Code:"+wTotalBoard.ToString());
                Close();
                return;
            }

            for (ushort wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            { 
                //Get Card Information
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }

        }     

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
              
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            //Total Digital Output Port
            cbxPort.Items.Clear();
            if (sCardInfo[wBoardNo].wDIOPorts + sCardInfo[wBoardNo].wDOPorts > 0)
            {
                for (int wPortIndex = 0; wPortIndex < sCardInfo[wBoardNo].wDIOPorts + sCardInfo[wBoardNo].wDOPorts; wPortIndex++)
                {
                    cbxPort.Items.Add("Port " + wPortIndex.ToString());
                }

                cbxPort.SelectedIndex = 0;
            }

            this.Text = this.cbxSelBoard.Text + " Digital Output Pattern Generator(Cont.) Sample Program";
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            //Driver Close
            wRtn = UniDAQ.Ixud_DriverClose();
            Close();
        }

        private void btnOutput_Click(object sender, EventArgs e)
        {
            if (btnOutput.Text == "&ACTIVE")
            {
                btnOutput.Text = "&STOP";

                //Digital Output Pattern
                for (UInt16 wIndex = 0; wIndex < MAX_DATA_NUM; wIndex++)
                {
                    dwDOBuf[wIndex] = (UInt32)(wIndex & 0xFF);       
                }

                wBoardNo  = (ushort)cbxSelBoard.SelectedIndex;
                   
                //Start the Digital Output Pattern
                wRtn = UniDAQ.Ixud_StartDO(wBoardNo, (ushort)cbxPort.SelectedIndex,0, Convert.ToSingle(this.tbxRate.Text) * (float)1000.0, MAX_DATA_NUM, 0, dwDOBuf);
            }
            else
            {
                btnOutput.Text = "&ACTIVE";
                wRtn = UniDAQ.Ixud_StopDO(wBoardNo, (ushort)cbxPort.SelectedIndex);
            }

            while (btnOutput.Text == "&STOP")
            {
                Application.DoEvents();
            }           
        }


    } 
}