using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;    //namespace P100X_Ns 

namespace DIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }



        ushort wTotalBoards, wRtn, wBoardNo;
        uint hEvent;
        int wApcCount;
        UniDAQ.CallBackFun FuncAddress;
   
  
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UniDAQ.IXUD_DEVICE_INFO[] sDevInfo = new UniDAQ.IXUD_DEVICE_INFO[UniDAQ.MAX_BOARD_NUMBER];

        private void Form1_Load(object sender, EventArgs e)
        {
         FuncAddress = User_Callback_0;

        //Driver Initial
        byte[] szModeName = new byte[20];
        wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoards);
        if (wRtn != UniDAQ.Ixud_NoErr)
        {
             MessageBox.Show("Driver Initial Error!!Error Code:" + wRtn.ToString());
                Close();
                return;
        }

        //Get Card Information
        for (ushort wBoardIndex = 0; wBoardIndex <= (wTotalBoards - 1); wBoardIndex++)
        {
            wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDevInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);

            if(wRtn!= UniDAQ.Ixud_NoErr) 
            {
                MessageBox.Show("Get Card Information Err");
            }

            this.cbxBoardNo.Items.Add(Encoding.ASCII.GetString(szModeName));

        }


        this.cbxTrigger.SelectedIndex = 0;
        this.cbxBoardNo.SelectedIndex = 0;

       
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            wRtn = UniDAQ.Ixud_DriverClose();
            Close();
            return;
        }

        private void cmdActive_Click(object sender, EventArgs e)
        {
            //Dim hEvent As Long
        //Dim i As Integer
        //Dim ApcReg As Long
        int wTriggerMode;

        if (cmdActive.Text == "&ACTIVE"){

            wBoardNo = (ushort)this.cbxBoardNo.SelectedIndex;
            

            hEvent = 0; //Initial hEvent


            wApcCount = 0; //Callback function count for Int Source 0

            cmdActive.Text = "&STOP";

            switch (this.cbxTrigger.SelectedIndex)
            {
                case 0 :
                    wTriggerMode = 5;
                    break;
                case 1 :
                    wTriggerMode = 9;
                    break;
                case 2:
                    wTriggerMode = 13;
                    break;
                default :
                    MessageBox.Show("Err");
                    wRtn = UniDAQ.Ixud_DriverClose();
                    Close();
                    return;

            }



            //Register Callback function, Source = 1(INT_0)
            wRtn = UniDAQ.Ixud_SetEventCallback(wBoardNo, (ushort)wTriggerMode, 1,ref hEvent , FuncAddress, 0); //Register APC

            if (wRtn != 0)
            {
                lstMsg.Items.Add("Register APC Error!!");
            }else{
                lstMsg.Items.Add(" Register APC OK!!!");
            }


            //Install IRQ number
            wRtn = UniDAQ.Ixud_InstallIrq(wBoardNo, 0x1);
            if (wRtn!=0)
            {
                lstMsg.Items.Add("Install IRQ Error");
            }else{
                lstMsg.Items.Add("Install IRQ Success!!!");
            }


            //Set Count 3 to Mode 3 Generate 80000/40000 = 2Hz Clock
            wRtn = UniDAQ.Ixud_SetCounter(wBoardNo, 2, 3, 40000);
        }else{
            cmdActive.Text = "&ACTIVE";
            lstMsg.Items.Add(" Stop Counter Trigger");
            //Stop Counter
            wRtn = UniDAQ.Ixud_SetCounter(wBoardNo, 2, 2, 1);
            // Revmove the Interrupt
            wRtn = UniDAQ.Ixud_RemoveIrq(wBoardNo);
            lstMsg.Items.Add("Stop Interrupt!!");

            wRtn = UniDAQ.Ixud_RemoveEventCallback(wBoardNo, 0); //Remove APC
            lstMsg.Items.Add("Remove APC!!");

            lstMsg.Items.Add("Event Count" + Convert.ToString(wApcCount));

        }


        while (this.cmdActive.Text == "&STOP")
        {

            this.tbxAPCCount.Text = Convert.ToString(wApcCount);

            Application.DoEvents();

        }

        }

       

 
       public void User_Callback_0(UInt32 lParm)
        {
            
        wApcCount = wApcCount + 1;
        if (wApcCount == 10000)
        {
            wApcCount = 0;
        }
            
        }

        
    } 
}