using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;    //namespace P100X_Ns 

namespace DIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }



        ushort wTotalBoards, wRtn, wBoardNo,wCounter,wMode;



        UniDAQ.IXUD_CARD_INFO sSelCardInfo;
        UniDAQ.IXUD_DEVICE_INFO sSelDevInfo;

        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UniDAQ.IXUD_DEVICE_INFO[] sDevInfo = new UniDAQ.IXUD_DEVICE_INFO[UniDAQ.MAX_BOARD_NUMBER];

        private void Form1_Load(object sender, EventArgs e)
        {
       

        //Driver Initial
        byte[] szModeName = new byte[20];
        wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoards);
        if (wRtn != UniDAQ.Ixud_NoErr)
        {
             MessageBox.Show("Driver Initial Error!!Error Code:" + wRtn.ToString());
                Close();
                return;
        }

        //Get Card Information
        for (ushort wBoardIndex = 0; wBoardIndex <= (wTotalBoards - 1); wBoardIndex++)
        {
            wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDevInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);

            if(wRtn!= UniDAQ.Ixud_NoErr) 
            {
                MessageBox.Show("Get Card Information Err");
            }

            this.cbxBoardNo.Items.Add(Encoding.ASCII.GetString(szModeName));

            //sDevInfo[wBoardIndex] = sGetDevInfo;
            //sCardInfo[wBoardIndex] = sGetCardInfo;
        }


       
        this.cbxBoardNo.SelectedIndex = 0;

       
        }

    

       


        private void btnActive_Click(object sender, EventArgs e)
        {
        uint CountVal;
        double DutyVal;
        double SourceCLK;

        wBoardNo = (ushort)cbxBoardNo.SelectedIndex;


        SourceCLK = 80000.0;  //80 kHz

        wCounter = 0;
        wMode = 3;
        CountVal = Convert.ToUInt16(SourceCLK / Convert.ToSingle(this.tbxFrequency.Text)); //Internal Clock is CLK2 = 80 kHz
        wRtn = UniDAQ.Ixud_SetCounter(wBoardNo, wCounter, wMode, CountVal); //Counter 1 Output Frequency

        wCounter = 1;
        wMode = 1;
        DutyVal = CountVal * (Convert.ToSingle(this.tbxDuty.Text) * 0.01);
        wRtn = UniDAQ.Ixud_SetCounter(wBoardNo, wCounter, wMode, (uint)DutyVal); //Counter 2 Outupt Duty

        this.Text = "PWM Enable " + "[" + Convert.ToString(SourceCLK / Convert.ToSingle(CountVal)) + " Hz," + Convert.ToString((Convert.ToSingle(DutyVal) / Convert.ToSingle(CountVal)) * 100.0) + " %]";
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            wRtn = UniDAQ.Ixud_DisableCounter(wBoardNo, 0); //Stop Counter 0
            wRtn = UniDAQ.Ixud_DisableCounter(wBoardNo, 1); //Stop Counter 1

        this.Text = "PWM Disable";
        }

        private void cbxBoardNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            wBoardNo = (ushort)cbxBoardNo.SelectedIndex;
       


        sSelDevInfo = sDevInfo[wBoardNo];
        sSelCardInfo = sCardInfo[wBoardNo];

        this.Text = this.cbxBoardNo.Text + " PWM Output Sample Program";

        }

        
    } 
}