using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;    //namespace P100X_Ns 

namespace DIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }



        ushort wTotalBoards, wRtn, wBoardNo, wRtnClk;
        uint hEvent, DOvalue;
        int wApcCount,wTriggerMode,wTrgMode;
        UniDAQ.CallBackFun FuncAddress;
   
  
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UniDAQ.IXUD_DEVICE_INFO[] sDevInfo = new UniDAQ.IXUD_DEVICE_INFO[UniDAQ.MAX_BOARD_NUMBER];

        private void Form1_Load(object sender, EventArgs e)
        {
         //FuncAddress = User_Callback_0;
            FuncAddress = MyApcFunction;
        //Driver Initial
        byte[] szModeName = new byte[20];
        wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoards);
        if (wRtn != UniDAQ.Ixud_NoErr)
        {
             MessageBox.Show("Driver Initial Error!!Error Code:" + wRtn.ToString());
                Close();
                return;
        }

        //Get Card Information
        for (ushort wBoardIndex = 0; wBoardIndex <= (wTotalBoards - 1); wBoardIndex++)
        {
            wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDevInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);

            if(wRtn!= UniDAQ.Ixud_NoErr) 
            {
                MessageBox.Show("Get Card Information Err");
            }

            this.cbxBoardNo.Items.Add(Encoding.ASCII.GetString(szModeName));

        }


        //this.cbxTrigger.SelectedIndex = 0;
        this.cbxBoardNo.SelectedIndex = 0;
        this.TriggerMode.SelectedIndex = 0;
        DOvalue = 0;
       
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            DOvalue += 1;
            if(DOvalue > 10){
                DOvalue = 0;
            }
            wRtnClk = UniDAQ.Ixud_WriteDO((ushort)wBoardNo, 1, DOvalue);
            this.DoVAL.Text = Convert.ToString(DOvalue);
        }

        public void MyApcFunction(UInt32 lParm)
        {

            wApcCount = wApcCount + 1;
            if (wApcCount == 10000)
            {
                wApcCount = 0;
            }

        }

        private void cmdActive_Click(object sender, EventArgs e)
        {
            cbxBoardNo.Enabled = false;
            TriggerMode.Enabled = false;

            if(cmdActive.Text == "&ACTIVE") 
            {
                wBoardNo = (ushort)this.cbxBoardNo.SelectedIndex;//
                wRtn = UniDAQ.Ixud_SetDIOMode(wBoardNo, 0, 0); //Set Port 0(A) to DI Mode
                if(wRtn != 0)
                {
                    lstMsg.Items.Add("Set Port A to DI Mode Error!!");
                }else{
                    lstMsg.Items.Add(" Set Port A to DI Mode OK!!!");
                }


                wRtn = UniDAQ.Ixud_SetDIOMode(wBoardNo, 1, 1); //Set Port 1(B) to DO Mode
                if(wRtn != 0)
                {
                    lstMsg.Items.Add("Set Port B to DO Mode Error!!");
                }else{
                    lstMsg.Items.Add(" Set Port B to DO Mode OK!!!");
                }

                wTrgMode = TriggerMode.SelectedIndex;

                wRtn = UniDAQ.Ixud_SetDITriggerMode(wBoardNo, 1, (ushort)wTrgMode, 5);// '0:Compare 1:change

                if(wRtn != 0)
                {
                    lstMsg.Items.Add("SetDITriggerMode Error!!");
                }else{
                    lstMsg.Items.Add("SetDITriggerMode OK!!!");
                }

                hEvent = 0; //Initial hEvent
                wApcCount = 0; //Callback function count for Int Source 0
                cmdActive.Text = "&STOP";

                wTriggerMode = 9;// IXUD_HARDWARE_INT Or IXUD_ACTIVE_HIGH

                //Register Callback function, Source = 1(INT_0)
                wRtn = UniDAQ.Ixud_SetEventCallback(wBoardNo, (ushort)wTriggerMode, 1, ref hEvent, FuncAddress, 0); //Register APC

                if(wRtn != 0){
                    lstMsg.Items.Add("Register APC Error!!");
                }else{
                    lstMsg.Items.Add(" Register APC OK!!!");
                }


                //Install IRQ number
                wRtn = UniDAQ.Ixud_InstallIrq(wBoardNo, 0x1);
                if(wRtn != 0)
                {
                    lstMsg.Items.Add("Install IRQ Error");
                }else{
                    lstMsg.Items.Add("Install IRQ Success!!!");
                }

                Timer1.Enabled = true;
            }else{
                cmdActive.Text = "&ACTIVE";
                lstMsg.Items.Add(" Stop Counter Trigger");
                // Revmove the Interrupt
                wRtn = UniDAQ.Ixud_RemoveIrq(wBoardNo);
                lstMsg.Items.Add("Stop Interrupt!!");

                wRtn = UniDAQ.Ixud_RemoveEventCallback(wBoardNo, 0); //Remove APC
                lstMsg.Items.Add("Remove APC!!");

                lstMsg.Items.Add("Event Count" + Convert.ToString(wApcCount));
                Timer1.Enabled = false;
                cbxBoardNo.Enabled = true;
                TriggerMode.Enabled = true;
            }


            while(this.cmdActive.Text == "&STOP")
            {
                this.tbxAPCCount.Text = Convert.ToString(wApcCount);
                Application.DoEvents();
            }
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            wRtn = UniDAQ.Ixud_DriverClose();
            Close();
            return;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            wRtn = UniDAQ.Ixud_RemoveEventCallback(wBoardNo, 0); //Remove APC
            wRtn = UniDAQ.Ixud_RemoveIrq(wBoardNo);
            Timer1.Enabled = false;
        }

 


 
    
        
    } 
}