using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;    //namespace P100X_Ns 

namespace AnalogOutput
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
      
       
        ushort wTotalBoard, wRtn, wBoardNo; 
       
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[32];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[32];

        private void Form1_Load(object sender, EventArgs e)
        {

            byte[] szModeName = new byte[20];
            //Driver Initial
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Inital Error!!Error Code:"+wTotalBoard.ToString());
                Close();
                return;
            }

            for (ushort wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            { 
                //Get Card Information
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }

            cbxSelBoard.SelectedIndex = 0;
            Mode.SelectedIndex = 2;
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            //Driver Close
            wRtn = UniDAQ.Ixud_DriverClose();
            Close();
        }

        private void btnOutput_Click(object sender, EventArgs e)
        {
            ushort wCounterCh, wCounterMode,i;
            UInt32 wCounterValue;
                    
            wBoardNo  = (ushort)cbxSelBoard.SelectedIndex;


            if ((sCardInfo[wBoardNo].wCounterChannels) == 0)
            {
                MessageBox.Show ("Not support timer counter");
                Close();
                return;
            }

            listBox1.Items.Clear();

            wCounterValue = System.Convert.ToUInt16(Value.Text);
            wCounterCh = System.Convert.ToUInt16(Channel.SelectedIndex);
            wCounterMode = System.Convert.ToUInt16(Mode.SelectedIndex);

            //set counter
            wRtn= UniDAQ.Ixud_SetCounter (wBoardNo, wCounterCh, wCounterMode, wCounterValue);

            //read counter
            for (i = 0; i <= 100; i++)
            {
                wRtn = UniDAQ.Ixud_ReadCounter(wBoardNo, wCounterCh, ref wCounterValue);
                listBox1.Items.Add(wCounterValue);
            }       
      }

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
            ushort i;

            this.Text = this.cbxSelBoard.Text + " Timer Counter";
            Channel.Items.Clear();
            Channel.Text="";

            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;

            //whether have the timer counter
            if ((sCardInfo[wBoardNo].wCounterChannels) == 0)
            {
                MessageBox.Show("Not support timer counter");
                btnOutput.Enabled = false;
            }
            else
            { 
            for(i=0;i<(sCardInfo[wBoardNo].wCounterChannels);i++)
                Channel.Items.Add (i);

                Channel.SelectedIndex = 0;
                btnOutput.Enabled = true;

            }
        }

    } 
}