%(m-file)ICP DAS UniDAQ MATLAB Sample Code[Analog Output(float)]
clear all

disp('ICP DAS UniDAQ Matlab Sample Code')
disp('Analog output(float) Sample Program')
%Load the UniDAQ DLL
if ~libisloaded('UniDAQ')    
    loadlibrary('UniDAQ.dll','UniDAQ.h'); %Load UniDAQ DLL
    disp('Load the ICP DAS UniDAQ DLL')
end

%libfunctions UniDAQ -full %List the UniDAQ DLL Function 

global wRtn
wRtn = uint16(0);
global  wIndex
wIndex = uint16(0);
global wTotalBoard
wTotalBoard = uint16(0);
pwTotalBoard = libpointer('uint16Ptr',wTotalBoard);
wBoardNo = uint16(0);
wAOChannel = uint16(0);
wAOConfig = uint16(0);
fAOValue = single(0.0);

%DevInfo Init
sDevInfo.dwSize=0;			%Struct Size	
sDevInfo.wVendorID=0;			%Vendor ID
sDevInfo.wDeviceID=0;			%Device ID	
sDevInfo.wSubVendorID=0;		%Sub Vendor ID
sDevInfo.wSubDeviceID=0;		%Sub Device ID
sDevInfo.dwBAR=zeros(1,6);			%PCI Bar 0 ~ 5

sDevInfo.BusNo=0;			%the PCI Bus No. in mainboard
sDevInfo.DevNo=0;			%the Slot No. in PCI bus
sDevInfo.IRQ=0;				%IRQ No.
sDevInfo.Aux=0;				%Sub Aux for Tiger series,0xFF=N/A

sDevInfo.dwReserved1=zeros(1,6);   %Reserver

strucDevInfo = libstruct('s_IXUD_DEVICE_INFO_',sDevInfo);
psDevInfo = libpointer('s_IXUD_DEVICE_INFO_Ptr',strucDevInfo);

%sCardInfo Init
sCardInfo.dwSize=0;			%Structure size
sCardInfo.dwModelNo=0;		%Model Number
	
%CardID is update when calling the function each time.
sCardInfo.CardID=0;			%for new cards, 0xFF=N/A
sCardInfo.wSingleEnded=0;		%for new cards,1:S.E 2:D.I.F,0xFF=N/A
sCardInfo.wAIOResolution=0;	%AI/AO Resolution High byte is AI, Low byte is AO

sCardInfo.wAIChannels=0;		%Number of AI channels(AD)
sCardInfo.wAOChannels=0;		%Number of AO channels(DA)

sCardInfo.wDIPorts=0;			%Number of DI ports
sCardInfo.wDOPorts=0;			%Number of DO ports

sCardInfo.wDIOPorts=0;			%Number of DIO ports
sCardInfo.wDIOPortWidth=0;		%The width is 8/16/32 bit.

sCardInfo.wCounterChannels=0;	%Number of Timers/Counters
sCardInfo.wMemorySize=0;		%PCI-M512==>512, Units in KB.

sCardInfo.dwReserved1=zeros(1,6);   %Reserver 

strucCardInfo = libstruct('s_IXUD_CARD_INFO_',sCardInfo);
psCardInfo = libpointer('s_IXUD_CARD_INFO_Ptr',strucCardInfo);

sModelName='Unknow Device       ';%Size char 20

clear sDevInfo
clear sCardInfo

%DriverInit
[wRtn,wTotalBoard] = calllib('UniDAQ','Ixud_DriverInit',pwTotalBoard);
if wRtn ~= 0
    disp(['Ixud_DriverInit fail , Error:  ' num2str(wRtn) ])    
else
    if ~wTotalBoard
        disp('Don''t find and board')
        return
    else    
        disp(['Driver initiate. Get Total Board number:  ' num2str(wTotalBoard) ]) 
    end
end

%Get board information
for wIndex = 0: wTotalBoard -1
    [wRtn,sDevInfo,sCardInfo,sModelName] = calllib('UniDAQ','Ixud_GetCardInfo',wIndex,psDevInfo,psCardInfo,sModelName);
    disp('BoardNo ModelName')
    disp([  num2str(wIndex) '  ' sModelName])
    %sprintf('%4d %s',wIndex, sModelName)
end

disp(['Please select the Board Number:[0-' num2str(wTotalBoard-1) ']'])
wBoardNo = input('');

[wRtn,sDevInfo,sCardInfo,sModelName] = calllib('UniDAQ','Ixud_GetCardInfo',wBoardNo,psDevInfo,psCardInfo,sModelName);

wAOChannel = input(['Please select the Analog Output channel[0~' num2str(sCardInfo.wAOChannels-1) ']:']);
disp('[0]0 ~ 5 V')
disp('[1]+/- 5 V')
disp('[2]0 ~ 10 V ')
disp('[3]+/- 10 V')
disp('Select the Analog Output Range:');
wAOConfig = input('');
fAOValue = input('Please input the Output Voltage[V]:');
%Config AO Range
wRtn = calllib('UniDAQ','Ixud_ConfigAO',wBoardNo,wAOChannel,wAOConfig);
if wRtn
    disp(['Ixud_ConfigAO Error.Error Code:' num2str(wRtn)])
    return
end
%Output Voltage
wRtn = calllib('UniDAQ','Ixud_WriteAOVoltage',wBoardNo,wAOChannel,fAOValue);
if wRtn
    disp(['Ixud_WriteAOVoltage Error.Error Code:' num2str(wRtn)])
    return
end
disp(['Write AO Channel' num2str(wAOChannel) ', Voltage ' num2str(fAOValue)])

%Driver Close
wRtn = calllib('UniDAQ','Ixud_DriverClose');
if wRtn ~= 0
    disp(['Ixud_DriverClose fail , Error:  ' num2str(wRtn) ]) 
end

%Unload the UniDAQ DLL
if libisloaded('UniDAQ')
    %unloadlibrary('UniDAQ');
    disp('Unload the ICP DAS UniDAQ DLL')
end
    